CREATE DATABASE IF NOT EXISTS tfc;
USE tfc;

DROP TABLE IF EXISTS `tfc`.`persona`;
CREATE TABLE  `tfc`.`persona` (
  `nif` varchar(10) NOT NULL,
  `nombre` varchar(20) DEFAULT NULL,
  `apellido1` varchar(20) DEFAULT NULL,
  `apellido2` varchar(20) DEFAULT NULL,
  `telefono` varchar(11) DEFAULT NULL,
  `movil` varchar(11) DEFAULT NULL,
  `email` varchar(40) DEFAULT NULL,
  `direccion` varchar(40) DEFAULT NULL,
  `poblacion` varchar(40) DEFAULT NULL,
  `cpostal` varchar(10) DEFAULT NULL,
  `fechaAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `pass` varchar(10) DEFAULT NULL,
  `observacion` varchar(255) DEFAULT NULL,
  `tipo` varchar(1) NOT NULL,
  PRIMARY KEY (`nif`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `tfc`.`reparacion`;
CREATE TABLE  `tfc`.`reparacion` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nifCliente` varchar(10) NOT NULL,
  `nifReparador` varchar(10) NOT NULL,
  `fechaEntrada` date DEFAULT NULL,
  `fechaFin` date DEFAULT NULL,
  `estado` varchar(20) DEFAULT NULL,
  `precio` double unsigned DEFAULT '0',
  `comentario` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `tfc`.`compra`;
CREATE TABLE  `tfc`.`compra` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nifCliente` varchar(10) NOT NULL,
  `fecha` date DEFAULT NULL,
  `articulo` varchar(255) DEFAULT NULL,
  `cantidad` int(11) DEFAULT NULL,
  `precio` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


Insert Into persona Values ('client','Jordi', 'Ferreiro', 'Colom', '938540666', '632198991','dreg2@hotmail.es', 'C/Josep Mar n1, 1-3', 'Da De Di', '08515', '2010-10-21', 'client','Usuari creat per fer de Client', 0)
Insert Into persona Values ('operari','David', 'Gonzalez', 'Ugarte', '938540777', '636151992','dfv2@hotmail.net', 'C/Jus Gall n14, 1-3', 'Rodter', '03519', '2010-10-21', 'operari','Usuari creat per fer de Operari de Tenda', 1)
Insert Into persona Values ('tecnic','Ester', 'Nesple', 'Vilar', '938540888', '636194913','dvcfv2@hotmail.uoc', 'C/Jo Raga n14, 1-3', 'Ter', '08610', '2010-10-21', 'tecnic','Usuari creat per fer de Tecnic', 2)
Insert Into persona Values ('admin','Marc', 'Martos', 'Garcia', '938549999', '616193994','drf32@hotmail.com', 'C/Oan Aga n14, 1-3', 'Roda', '08910', '2010-10-21', 'admin','Usuari creat per fer de Admin', 3)




--NO UTIL DE MOMENTO

DROP TABLE IF EXISTS `tfc`.`lineacompra`;
CREATE TABLE  `tfc`.`lineacompra` (
  `idFactura` int(11) NOT NULL,
  `linea` int(11) NOT NULL,
  `articulo` varchar(40) DEFAULT NULL,
  `cantidad` int(11) DEFAULT NULL,
  `precio` int(11) DEFAULT NULL,
  PRIMARY KEY (`idFactura`,`linea`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;