package controller;

/**
 *
 * @author OtakuFerreDavid
 */

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

import model.Compra;
import util.HibernateUtil;
//Classe que se encarga de manipular los datos (de las compras), cogerlos o insertarlos en la base de datos i asignarlo al 
//objeto correspondiente si es una salida de datos (de la base de datos)
public class GestioCompra extends HibernateUtil {

	//Metodo para insertar (i/o modificar) los datos en la base de datos
    public Compra add(Compra compra) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        session.saveOrUpdate(compra);
        session.getTransaction().commit();
        return compra;
    }
  //Metodo para modificar los datos en la base de datos
    public Compra update(Compra compra) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        session.update(compra);
        session.getTransaction().commit();
        return compra;
    } 
    //Metodo para borrar una reparacion dado un ID en la base de datos
    public Compra delete(Integer integer) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        Compra compra = (Compra) session.load(Compra.class, integer);
        if(null != compra) {
            session.delete(compra);
        }
        session.getTransaction().commit();
        return compra;
    }
  //Metodo que devuelve la compra identificada por el parametro que se le pasa
	public Compra getCompra(Integer id) {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        Compra compra = null;
        try {

            compra = (Compra)session.get(Compra.class, id);

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return compra;
    }
//Metodo que devuelve una lista con los objetos que contengan el string que se le pasa
	public List<Compra> list(String nif) {

       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
       session.beginTransaction();
       List<Compra> compras = null;
       try {

           compras = (List<Compra>)session.createQuery("from Compra Where nifCliente LIKE '%"+nif+"%'").list();

       } catch (HibernateException e) {
           e.printStackTrace();
           session.getTransaction().rollback();
       }
       session.getTransaction().commit();
       return compras;
   }
//Metodo que devuelve una lista con los objetos de la tabla Compra
	public List<Compra> list() {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        List<Compra> compras = null;
        try {

            compras = (List<Compra>)session.createQuery("from Compra").list();

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return compras;
    }
}

