package controller;

/**
 *
 * @author OtakuFerreDavid
 */

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

import model.Persona;
import util.HibernateUtil;

//Classe que se encarga de manipular los datos (de personas) , cogerlos o insertarlos en la base de datos i asignarlo al 
//objeto correspondiente si es una salida de datos (de la base de datos)
public class GestioPersones extends HibernateUtil {

	//Metodo para insertar (i/o modificar) los datos en la base de datos
    public Persona add(Persona persona) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        session.saveOrUpdate(persona);
        session.getTransaction().commit();
        return persona;
    }
  //Metodo para insertar (i/o modificar) los datos en la base de datos
    public Persona update(Persona persona) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        session.update(persona);
        session.getTransaction().commit();
        return persona;
    }
    //Metodo para borrar una reparacion dado el NIF en la base de datos
    public Persona delete(String string) {
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        Persona persona = (Persona) session.load(Persona.class, string);
        if(null != persona) {
            session.delete(persona);
        }
        session.getTransaction().commit();
        return persona;
    }
//Metodo que devuelve la persona identificada por el parametro que se le pasa
	public Persona getPersona(String nif) {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        Persona persona = null;
        try {

            persona = (Persona)session.get(Persona.class,nif);

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return persona;
    }
	//Metodo que devuelve una lista con los objetos de la tabla Persona
	public List<Persona> list() {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        List<Persona> persones = null;
        try {

            persones = (List<Persona>)session.createQuery("from Persona").list();

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return persones;
    }
	//Metodo que devuelve una lista con los objetos que contengan el string que se le pasa
	public List<Persona> list(String nif) {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        List<Persona> persones = null;
        try {

            persones = (List<Persona>)session.createQuery("from Persona where nif LIKE '%"+nif+"%'").list();

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return persones;
    }
}
