package controller;

/**
*
* @author OtakuFerreDavid
*/
// 
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.classic.Session;

import util.HibernateUtil;

import model.Reparacion;

// Classe que se encarga de manipular los datos (de las reparaciones), cogerlos o insertarlos en la base de datos i asignarlo al 
//objeto correspondiente si es una salida de datos (de la base de datos)

public class GestioReparacion extends HibernateUtil {

//Metodo para insertar (i/o modificar) los datos en la base de datos 
   public Reparacion add(Reparacion reparacion) {
       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
       session.beginTransaction();
       session.saveOrUpdate(reparacion);
       session.getTransaction().commit();
       return reparacion;
   }
 //Metodo para modificar los datos en la base de datos
   public Reparacion update(Reparacion reparacion) {
       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
       session.beginTransaction();
       session.update(reparacion);
       session.getTransaction().commit();
       return reparacion;
   } 
 //Metodo para borrar una reparacion dado un ID en la base de datos
   public Reparacion delete(Integer string) {
       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
       session.beginTransaction();
       Reparacion reparacion = (Reparacion) session.load(Reparacion.class, string);
       if(null != reparacion) {
           session.delete(reparacion);
       }
       session.getTransaction().commit();
       return reparacion;
   }

	public Reparacion getReparacion(Integer id) {

        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        session.beginTransaction();
        Reparacion reparacion = null;
        try {

            reparacion = (Reparacion)session.get(Reparacion.class, id);

        } catch (HibernateException e) {
            e.printStackTrace();
            session.getTransaction().rollback();
        }
        session.getTransaction().commit();
        return reparacion;
    }
	//Metodo que devuelve una lista con los objetos de la tabla Reparacion que contienen el atributo que se le passa como parametro
	public List<Reparacion> list(String nif) {

       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
       session.beginTransaction();
       List<Reparacion> reparaciones = null;
       try {

           reparaciones = (List<Reparacion>)session.createQuery("from Reparacion Where nifCliente LIKE '%"+nif+"%'").list();

       } catch (HibernateException e) {
           e.printStackTrace();
           session.getTransaction().rollback();
       }
       session.getTransaction().commit();
       return reparaciones;
   }
	//Metodo que devuelve una lista con los objetos de la tabla Reparacion
	public List<Reparacion> list() {

	       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
	       session.beginTransaction();
	       List<Reparacion> reparaciones = null;
	       try {

	           reparaciones = (List<Reparacion>)session.createQuery("from Reparacion").list();

	       } catch (HibernateException e) {
	           e.printStackTrace();
	           session.getTransaction().rollback();
	       }
	       session.getTransaction().commit();
	       return reparaciones;
	   }
	//Metodo que devuelve una lista con los objetos de la tabla Reparacion que contienen el atributo que se le passa como parametro
	public List<Reparacion> listEstado(String estado) {

	       Session session = HibernateUtil.getSessionFactory().getCurrentSession();
	       session.beginTransaction();
	       List<Reparacion> reparaciones = null;
	       try {

	           reparaciones = (List<Reparacion>)session.createQuery("from Reparacion Where estado='"+estado+"'").list();

	       } catch (HibernateException e) {
	           e.printStackTrace();
	           session.getTransaction().rollback();
	       }
	       session.getTransaction().commit();
	       return reparaciones;
	   }
	
}
