package view;
import java.util.List;
import java.util.Map;

import controller.GestioCompra;
import model.Compra;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

import org.apache.struts2.interceptor.validation.SkipValidation;

/**
 *
 * @author OtakuFerreDavid
 */
public class CompraAction extends ActionSupport {

    private static final long serialVersionUID = 9149826260758390091L;
    private Compra compra;
    private List<Compra> compraList;
    private Integer id;
    private String nifCli;


	private GestioCompra linkController;

    public CompraAction() {
        linkController = new GestioCompra();
    }
    
    public String execute() {
    	if (compra!=null){
    		linkController.add(getCompra());
        }else{
        	linkController.update(getCompra());
        }
        return SUCCESS;
    }
  //Metodo para dar de alta una compra a la base de datos
    public String addCompra() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        try {
        linkController.add(getCompra());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
  //Metodo que permite modificar los datos de una compra dado un nif que se passa des de la web.
    public String updateCompra() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        try {
        linkController.update(getCompra());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
  //Metodo que nos devuelve la compra que se quiere modificar para poderla cargar luego en la pagina
    @SkipValidation
    public String editCompra(){
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
		if (compra != null && compra.getId() != null) {
			compra = linkController.getCompra(compra.getId());
			}
		return "success";
	} 
    // Metodo que borra la compra dado el id que se passa des de la web.
    @SkipValidation
    public String deleteCompra() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        linkController.delete(getId());
        return SUCCESS;
    }
 // Metodo que nos devuelve una list de todas las compras que contengan el nif que se le pasa como atributo del JSP
    @SkipValidation
    public String listaCompras() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
    	if (getNifCliente().equalsIgnoreCase("0"))
    	{
    		this.compraList = linkController.list();
    	}
    	else{ 
    		this.compraList = linkController.list(getNifCliente());
    	}
        return SUCCESS;
    }
 // Metodo que nos devuelve una lista de todas las compras del cliente que esta logeado
    @SkipValidation
    public String listaMisCompras() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	this.compraList = linkController.list((String) session.get("Id"));
        return SUCCESS;
    }
    //Metodos para acceder a los datos del objeto Compra del JSP
    public Compra getCompra() {
        return compra;
    }
    public List<Compra> getCompraList() {
        return compraList;
    }
    public void setCompra(Compra compra) {
        this.compra = compra;
    }
    public void setCompraList(List<Compra> comprasList) {
        this.compraList = comprasList;
    }
    public Integer getId() {
        return id;
    }
    public void setId(Integer id) {
        this.id = id;
    }
    public String getNifCliente() {
        return compra.getNifCliente();
    }
    public void setNifCliente(String nifCliente) {
        this.compra.setNifCliente(nifCliente);
    }
}