package view;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.validation.SkipValidation;

import controller.GestioPersones;
import model.Persona;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

/**
 *
 * @author OtakuFerreDavid
 */
/** Los metodos de validacion de session que se repiten en casi todas las classes y metodos, se podrian simplificar
en este caso dada la embergadura no lo he considerado oportuno, pero para una futura versin eso se tendria
que arreglar
*/


public class PersonaAction extends ActionSupport {

    private static final long serialVersionUID = 9149826260758390091L;
    private Persona persona;
    private List<Persona> personaList;
    private String nif;
    private GestioPersones linkController;

	// 0 - Cliente
	// 1 - Operario Tienda
	// 2 - Tecnico
	// 3 - Administrador
	// antes de la realizacin de los metodos se comprueva si el ususario tiene permisos
	
    public PersonaAction() {
        linkController = new GestioPersones();
    }
        
    public String execute() {
    	if(null != persona) {
    		linkController.add(getPersona());
        }
        return SUCCESS;
    }

    //Metodo para dar de alta un cliente a la base de datos
    public String addPersona() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
			System.out.println("INPUT!");
    		return INPUT;
    	}
        try {
        linkController.add(getPersona());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
    
    //Metodo que permite modificar los datos el cliente dado un nif que se passa des de la web.
    public String updatePersona() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        try {
        linkController.update(getPersona());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
    
    //Metodo que nos devuelve la persona que se quiere modificar para poderla cargar luego en la pagina
    @SkipValidation
    public String editPersona(){
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
		if (persona != null && persona.getNif() != null) {
			persona = linkController.getPersona(persona.getNif());
			}
		return "success";
	} 
    // Metodo que borra el cliente dado un nif que se passa des de la web.
    @SkipValidation
    public String borraPersona() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        linkController.delete(getNif());
        return SUCCESS;
    }
    // Metodo que nos devuelve una lista de todas las personas que contengan el nif que se le pasa como atributo
    @SkipValidation
    public String listaPersonas() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}    	
    	this.personaList = linkController.list(getNifCliente());
        return SUCCESS;
    }
    //Metodos para acceder a los datos del objeto Persona del JSP
    public Persona getPersona() {
        return persona;
    }
    public List<Persona> getPersonaList() {
        return personaList;
    }
    public void setPersona(Persona persona) {
        this.persona = persona;
    }
    public void setPersonaList(List<Persona> personasList) {
        this.personaList = personasList;
    }
    public String getNifCliente() {
        return persona.getNif();
    }
    public void setNifCliente(String nifCliente) {
        this.persona.setNif(nifCliente);
    }
  	public String getNif() {
		return nif;
	}
	public void setNif(String nif) {
		this.nif = nif;
	}
}