package view;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.validation.SkipValidation;


import controller.GestioReparacion;
import model.Reparacion;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

/**
 *
 * @author OtakuFerreDavid
 */
public class ReparacionAction extends ActionSupport {

    private static final long serialVersionUID = 9149826260758390091L;
    private Reparacion reparacion;
    private List<Reparacion> reparacionList;
    private Integer id;


	// 0 - Cliente
	// 1 - Operario Tienda
	// 2 - Tecnico
	// 3 - Administrador
    
	

	private GestioReparacion linkController;

    public ReparacionAction() {
        linkController = new GestioReparacion();
    }
    
    // Actualment fora de servei
    public String execute() {
    	if (reparacion!=null){
    		addReparacion();
        }
        return SUCCESS;
    }
  //Metodo para dar de alta una reparacin a la base de datos
    public String addReparacion() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
    		
        try {
        linkController.add(getReparacion());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
  //Metodo que permite modificar los datos de las reparaciones dado un nif que se passa des de la web.
    public String updateReparacion() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==1)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        try {
        linkController.update(getReparacion());
        }catch(Exception e) {
            e.printStackTrace();
        }
        return SUCCESS;
    }
  //Metodo que nos devuelve la reparacion que se quiere modificar para poderla cargar luego en la pagina
    @SkipValidation
    public String editReparacion(){
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==1)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
		if (reparacion != null && reparacion.getId() != null) {
			reparacion = linkController.getReparacion(reparacion.getId());
			}
		return "success";
	} 
 // Metodo que borra la reparacion dado el id que se passa des de la web.
    @SkipValidation
    public String deleteReparacion() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==1)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
        linkController.delete(getId());
        return SUCCESS;
    }
 // Metodo que nos devuelve una lista de todas las reparaciones del cliente que esta logeado
    @SkipValidation
    public String listaMisReparaciones() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	this.reparacionList = linkController.list((String) session.get("Id"));
        return SUCCESS;
    }
    // Metodo que nos devuelve una lista de todas las reparaciones que contengan el nif que se le pasa como atributo
    @SkipValidation
    public String listaReparaciones() {
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
    	if (getNifCliente().equalsIgnoreCase("0"))
    	{
    		this.reparacionList = linkController.list();
    	}
    	else{ 
    		this.reparacionList = linkController.list(getNifCliente());
    	}
        return SUCCESS;
    }
    // Metodo que nos devuelve una lista de todas las reparaciones del estado que se le pasa des del JSP
    @SkipValidation
    public String listaReparacionesEstado() { 
    	Map<String, Object> session = ActionContext.getContext().getSession();
    	if ((Integer)session.get("Type")==0 ||(Integer)session.get("Type")==2)
    	{
			addActionError(getText("error.no.permisos"));
    		return INPUT;
    	}
    	this.reparacionList = linkController.listEstado(getEstado());
        return SUCCESS;
    }
    //Metodos para acceder a los datos del objeto Reparacion del JSP
    
    public Reparacion getReparacion() {
        return reparacion;
    }
    public List<Reparacion> getReparacionList() {
        return reparacionList;
    }
    public void setReparacion(Reparacion reparacion) {
        this.reparacion = reparacion;
    }
    public void setReparacionList(List<Reparacion> reparacionesList) {
        this.reparacionList = reparacionesList;
    }
    public Integer getId() {
        return id;
    }
    public void setId(Integer id) {
        this.id = id;
    }
    public String getNifCliente() {
        return reparacion.getNifCliente();
    }
    public void setNifCliente(String nifCliente) {
        this.reparacion.setNifCliente(nifCliente);
    }
    public String getEstado() {
        return reparacion.getEstado();
    }
    public void setEstado(String estado) {
        this.reparacion.setEstado(estado);
    }
}